EDIT - bug #9762

Handle cultivars correctly in TaxEditor
09/15/2021 03:45 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.27

Severity: normal Found in Version:

Description

copied from #9755

)

If ICNCP is selected make only cultivar ranks (#6387) available

¢ If a cultivar rank is selected always show the according fields, no matter if ICNAFP or ICNCP is selected
o if "Cultivar" is selected show "Cultivar Group" and "Cultivar Name" (new field that should appear above "Cultivar Name")

o if "Cultivar Group" is selected show "Cultivar Group"

o if "Grex (ICNCP)" is selected show "Cultivar Group" (see also #9780)

for checking if a rank is a cultivar rank use Rank.isCultivar()
Discussion is still need for the following tasks:

¢ If ICNafp is selected do not show cultivar ranks

Rename Cultivar Name to Cultivar Epithet and Cultivar Group to Cultivar Group Epi. (to make it not too long)

¢ Make it possible via preferences to select in nomenclatural code field only from certain Codes (e.g. only ICN and ICNCP),
alternatively remove ICNCP from Codes as selecting one of the cultivar ranks (#6387) may be enough to decide that ICNCP is

meant (ask taxonomists for correctness of this idea)
¢ How to handle graft-chimaera and denomination class rank

Related issues:
Related to EDIT - feature request #9755: Open issues for cultivar handling

In Progress

Associated revisions

Revision f4caff64 - 09/17/2021 10:56 AM - Katja Luther

ref #9762: handle cultivars correctly in tax editor

Revision a1fd4a9b - 09/21/2021 09:20 AM - Katja Luther

ref #9762: cultivar group for cultivar and cultivar group and rank handling

Revision c58ab5d6 - 09/21/2021 11:15 AM - Katja Luther
ref #9762: avoid NPE

Revision 11fb1cef - 09/21/2021 08:41 PM - Andreas Miiller
ref #9762 fix NPE in cultivar handling

Revision 24d1dcbf - 09/22/2021 01:19 PM - Katja Luther

ref #9762: remove cultivar ranks for non cultivar codes and use isCultivar()

Revision 7a2e68e9 - 09/22/2021 03:09 PM - Katja Luther

ref #9762: smaller changes for cultivar names

Revision d29fd8e4 - 09/22/2021 04:26 PM - Andreas Miiller
ref #9762 fix NPE in cultivar handling

Revision 0ea0fdd3 - 09/23/2021 09:02 AM - Andreas Miiller
ref #9762, ref #9755 Add nameCache annotation to cultivar fields
https://dev.e-taxonomy.eu/redmine/issues/9755
https://dev.e-taxonomy.eu/redmine/issues/6387
https://dev.e-taxonomy.eu/redmine/issues/9780
https://dev.e-taxonomy.eu/redmine/issues/6387

Revision ab600885 - 09/23/2021 09:23 AM - Katja Luther

ref #9762: fix problems with rank combo and switch nomenclatural code

Revision 4451d6c9 - 09/24/2021 12:05 PM - Katja Luther
ref #9762: adapt 118n strings

History

#1 - 09/15/2021 03:46 PM - Andreas Miiller

- Related to feature request #9755: Open issues for cultivar handling added

#2 - 09/17/2021 11:51 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Now if ICNCP is selected only the cultivar ranks are available and the fields are displayed depending on the selected rank. Only the handling of grex
is missing, because of missing discussion result.

For reviewing the existing implementation set this ticket to resolved.

#3 - 09/20/2021 11:09 PM - Andreas Miiller
| got NPE when changing to ICNCP:

last remote method : http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/common.service
last remote request client time : 2021-09-20T23:07:44.432
last remote request response header time : Mon, 20 Sep 2021 21:07:44 GMT
client error time : 2021-09-20T23:08:16.693
login : admin
editor version : 5.27.0.202109201248
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.27.0.0.20210913
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_131
java.lang.NullPointerException
at eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement.createCultivarNameParts (NameDetailElement. java
:227)
at eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement.createSpecificNameParts (NameDetailElement. java
:199)
at eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement.createControls (NameDetailElement. java:117)
at eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement.createControls (NameDetailElement. java:l)
at eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement.updateContent (AbstractCdmDetailElement. java:
109)
at eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement.updateContent (NameDetailElement. java:164)
at eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement.setEntity (AbstractCdmDetailElement. java:85)
at eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection.setEntity (AbstractCdmDetailSection. java:155)
at eu.etaxonomy.taxeditor.ui.section.name.NonViralNameDetailElement.handleEvent (NonViralNameDetailElement.
java:176)
at eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement.propertyChange (AbstractCdmDetailElement. java
:206)
at eu.etaxonomy.taxeditor.ui.element.AbstractCdmFormElement.firePropertyChangeEvent (AbstractCdmFormElement
.Java:230)
at eu.etaxonomy.taxeditor.ui.combo.EnumComboElement.widgetSelected (EnumComboElement. java:319)
at org.eclipse.swt.widgets.TypedListener.handleEvent (TypedListener.java:249)
at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)
at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1079)
at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)
at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)
at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
at org.eclipse.ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)
at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)
at eu.etaxonomy.taxeditor.Application.start (Application.java:20)
at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher.java:104)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

#4 - 09/20/2021 11:15 PM - Andreas Miiller
Due to the above error (and maybe some similar errors) it is difficult to test.

Before passing back please do test on nightly if converting names from ICN to ICNCP back and forth works as expected and leave a message on
what you tested.

#5 - 09/20/2021 11:17 PM - Andreas Miiller

Cultivar Group should appear above Cultivar Name

#6 - 09/20/2021 11:18 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

Cultivar group should always appear while cultivar name should disappear if group (or grex) is selected. Currently it is the other way round.

#7 - 09/21/2021 02:14 PM - Andreas Miuller

- Target version changed from Release 5.45 to Release 5.27

#8 - 09/21/2021 10:40 PM - Andreas Miiller
- % Done changed from 0 to 40

Works correctly now except for 1 open issue: if cultivar epithet or cultivar group are changed the name Cache and the freetext editor text are not
updated.
Is this a cdmlib issue or a TaxEditor issue?

#9 - 09/21/2021 10:42 PM - Andreas Miiller
Andreas Miller wrote:
Works correctly now except for 1 open issue: if cultivar epithet or cultivar group are changed the name Cache and the freetext editor text are not

updated.
Is this a cdmlib issue or a TaxEditor issue?

| have to correct, only the nameCache is not updated.

#10 - 09/21/2021 10:48 PM - Andreas Miiller

There is the general issue that the details view does not update correctly when the nomenclatural code or ranks are changed. Is there a ticket for
this? Can you please link the ticket (and create if it does not exist yet)?

#11 - 09/21/2021 10:50 PM - Andreas Miiller
- Description updated

#12 - 09/22/2021 09:58 AM - Katja Luther

Andreas Milller wrote:
There is the general issue that the details view does not update correctly when the nomenclatural code or ranks are changed. Is there a ticket for
this? Can you please link the ticket (and create if it does not exist yet)?

This problem is known, | don't know if this ticket is the one | created for it: #8221

Closing or opening a collapsable field solves the problem.
https://dev.e-taxonomy.eu/redmine/issues/8221

#13 - 09/22/2021 12:38 PM - Andreas Miiller

- Description updated

New requirement:
® Rename Cultivar Name to Cultivar Epithet and Cultivar Group to Cultivar Group Epi. (to make it not too long)

AM: Bisher nennen wir das Attribut in TaxonName ,cultivarName*. Mir kommt der Begriff ,cultivarEpithet“ sinniger vor. Es handelt sich hier doch auch
lediglich um ein Epithet &hnlich wie beim Artepithet oder dem infraspezifischen Epithet, oder?

WGB:

Cultivar Epithet ist korrekt

#14 - 09/22/2021 12:40 PM - Andreas Miiller

- Description updated

#15 - 09/22/2021 12:40 PM - Andreas Miiller

- Description updated

This is decided now:

o if "Grex (ICNCP)" is selected show "Cultivar Group"

#16 - 09/22/2021 12:43 PM - Andreas Miiller

If ICNafp is selected do not show cultivar ranks

| suggest to implement it like this for now

#17 - 09/22/2021 03:08 PM - Katja Luther

Andreas Muller wrote:

This is decided now:

e if "Grex (ICNCP)" is selected show "Cultivar Group"

this is fixed

#18 - 09/22/2021 03:08 PM - Katja Luther

Andreas Muller wrote:

If ICNafp is selected do not show cultivar ranks

| suggest to implement it like this for now

this is implemented

#19 - 09/22/2021 03:10 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Andreas Muller wrote:

If ICNafp is selected do not show cultivar ranks

| suggest to implement it like this for now

this is implemented as well
#20 - 09/22/2021 04:35 PM - Andreas Miiller

- Status changed from Resolved to Feedback

There was also another NPE that | fixed (careful with name.getRank().doSomething() !!)

#21 - 09/22/2021 04:52 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther

When selecting a rank in the combobox the rank shown below in the list is selected and shown afterwards. The selection itself seems to be correct as
the correct rank abbreviation is shown in freetext editor.

#22 - 09/22/2021 04:56 PM - Andreas Miiller

When changing back from ICNCP to ICNAFP the rank list is not updated.
Also the currently selected rank is not removed (like it is the other way round).

#23 - 09/22/2021 04:58 PM - Andreas Miiller
Andreas Muller wrote:
Andreas Miiller wrote:
Works correctly now except for 1 open issue: if cultivar epithet or cultivar group are changed the name Cache and the freetext editor text

are not updated.
Is this a cdmlib issue or a TaxEditor issue?

| have to correct, only the nameCache is not updated.

This seems not to be fixed yet.
#24 - 09/23/2021 08:36 AM - Katja Luther
Andreas Muller wrote:
Andreas Miiller wrote:
Andreas Muller wrote:
Works correctly now except for 1 open issue: if cultivar epithet or cultivar group are changed the name Cache and the freetext editor

text are not updated.
Is this a cdmlib issue or a TaxEditor issue?

| have to correct, only the nameCache is not updated.

This seems not to be fixed yet.

this seems to be a cdmlib issue, because entering a species epithet changes the namecache, but the cultivar epithets not included.
#25 - 09/23/2021 08:43 AM - Katja Luther
Andreas Muller wrote:
When selecting a rank in the combobox the rank shown below in the list is selected and shown afterwards. The selection itself seems to be

correct as the correct rank abbreviation is shown in freetext editor.

| can't reproduce this with my local installation, | will check it with nightly, when | checked in the updated code.

#26 - 09/23/2021 09:03 AM - Andreas Miiller
Katja Luther wrote:
Andreas Muller wrote:

Andreas Muller wrote:

Andreas Mdiller wrote:
Works correctly now except for 1 open issue: if cultivar epithet or cultivar group are changed the name Cache and the freetext
editor text are not updated.
Is this a cdmlib issue or a TaxEditor issue?

I have to correct, only the nameCache is not updated.

This seems not to be fixed yet.

this seems to be a cdmlib issue, because entering a species epithet changes the namecache, but the cultivar epithets not included.

Ok, | found it. Fields that update the nameCache need an annotation @CacheUpdate("nameCache") . | changed and committed this.

#27 - 09/23/2021 01:15 PM - Andreas Miiller

Andreas Muller wrote:

Ok, | found it. Fields that update the nameCache need an annotation @CacheUpdate("nameCache") . | changed and committed this.

| tested it. It works now.

#28 - 09/23/2021 01:17 PM - Andreas Miiller

Katja Luther wrote:
Andreas Muller wrote:

When selecting a rank in the combobox the rank shown below in the list is selected and shown afterwards. The selection itself seems to be
correct as the correct rank abbreviation is shown in freetext editor.

| can't reproduce this with my local installation, | will check it with nightly, when | checked in the updated code.

This is fixed now.

#29 - 09/23/2021 01:29 PM - Andreas Miiller
- File picture728-1.png added

There is a single issue left. When switching back from ICNCP to ICNAFP there comes a warning like:

ED Der Cultivar Name muss gelscht werden -

Bestdtigen Sie, wenn Sie den Cultivar Mame lGschen und den Momenklatorischen
Code dndern wollen.

Yes | | Mo

This does not happen, if only the cultivar group epithet is set. Please do the check for both epithets.
And also change "Cultivar Name" to "Cultivar Epithet" in the warning and ofcourse adapt the warning so it reflects both cultivar epi and cultivar group
epi (e.g. by connecting via "and/or" )

#30 - 09/23/2021 05:42 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

Andreas Muller wrote:

There is a single issue left. When switching back from ICNCP to ICNAFP there comes a warning like:
ED Der Cultivar Name muss geldscht werden -

Bestdtigen Sie, wenn Sie den Cultivar Mame lgschen und den Nomenklatorischen
Code d@ndern wellen.

Ves | | Mo

This does not happen, if only the cultivar group epithet is set. Please do the check for both epithets.
And also change "Cultivar Name" to "Cultivar Epithet" in the warning and ofcourse adapt the warning so it reflects both cultivar epi and cultivar
group epi (e.g. by connecting via "and/or" )

This should be fixed.

#31 - 09/24/2021 11:57 AM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Miiller to Katja Luther
Katja Luther wrote:
Andreas Muller wrote:

There is a single issue left. When switching back from ICNCP to ICNAFP there comes a warning like:

ED Der Cultivar Name muss geldscht werden -

Bestatigen Sie, wenn Sie den Cultivar Name lGschen und den Momenklatorischen
Code dndern wollen,

Yes | | Mo

This does not happen, if only the cultivar group epithet is set. Please do the check for both epithets.
And also change "Cultivar Name" to "Cultivar Epithet" in the warning and ofcourse adapt the warning so it reflects both cultivar epi and
cultivar group epi (e.g. by connecting via "and/or" )

This should be fixed.

The warning text is not yet adapted (it is still "... Cultivar Name ..."). Instead it should be "... Cultivar Epithet and/or Cultivar Group Epithet ..."

#32 - 09/24/2021 11:57 AM - Andreas Miiller
- % Done changed from 40 to 90

#33 - 09/24/2021 01:30 PM - Andreas Miiller
- Status changed from Feedback to Closed
- % Done changed from 90 to 100

This seems to be fully fixed now.

Files
